Foreman - Bug #14225

super: no superclass method ‘load_defaults' for #<Class:..> on startup
03/16/2016 04:54 AM - Dominic Cleal

Status: Closed
Priority: High
Assignee: Dominic Cleal
Category: Settings
Target version: 1.12.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3332
Description

Nightly tests on Debian Wheezy and Ubuntu Precise are failing to start the application under Apache with the following error:

[ pid=9283 thr=19585120 file=utils.rb:176 time=2016-03-16 08:51:14.807 ]: *** Exception NoMethodEr
ror in PhusionPassenger::Rack::ApplicationSpawner (super: no superclass method "“load_defaults' for
#<Class:0x00000002e035d8>) (process 9283, thread #<Thread:0x0000000255b0c0>) :

from /usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-4.1.14.2/1ib/active_record/dyn
amic_matchers.rb:26:in "method_missing'

from /usr/share/foreman/app/models/setting/general.rb:5:in " load_defaults'

from /usr/share/foreman/config/initializers/foreman.rb:21:in “each'

from /usr/share/foreman/config/initializers/foreman.rb:21:in “<top (required)>"'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-4.1.14.2/1ib/active_support/d
ependencies.rb:241:in "~ load'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport—-4.1.14.2/1ib/active_support/d
ependencies.rb:241:in “block in load'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-4.1.14.2/1ib/active_support/d
ependencies.rb:232:1in "~ load_dependency'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-4.1.14.2/1ib/active_support/d
ependencies.rb:241:in "~ load'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/engine.rb:648:1
n ‘block in load_config_initializer'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport—-4.1.14.2/1ib/active_support/n
otifications.rb:161l:in "instrument'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/engine.rb:647:1
n " load_config_initializer'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/engine.rb:612:1
n "block (2 levels) in <class:Engine>'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/engine.rb:611:1
n “each'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/engine.rb:611:1
n ‘block in <class:Engine>'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/initializable.r
b:30:in "instance_exec'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/initializable.r
b:30:in "run'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/initializable.r
b:55:in “block in run_initializers'

from /usr/lib/ruby/1.9.1/tsort.rb:150:in “block in tsort_each'

from /usr/lib/ruby/1.9.1/tsort.rb:183:in ‘block (2 levels) in each_strongly_connected_comp
onent'

from /usr/lib/ruby/1.9.1/tsort.rb:210:in “block (2 levels) in each_strongly_connected_comp
onent_from'

from /usr/lib/ruby/1.9.1/tsort.rb:219:in “each_strongly_connected_component_from'

from /usr/lib/ruby/1.9.1/tsort.rb:209:in "block in each_strongly_connected_component_from'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/initializable.r
b:44:in “each'
from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/initializable.r
b:44:in “tsort_each_child’

from /usr/lib/ruby/1.

from /usr/lib/ruby/1.

.1/tsort.rb:203:in "“each_strongly_connected_component_from'
.1/tsort.rb:182:in “block in each_strongly_connected_component'

from /usr/lib/ruby/1.9.1/tsort.rb:180:in “each'

from /usr/lib/ruby/1.9.1/tsort.rb:180:in “each_strongly_connected_component'

from /usr/lib/ruby/1.9.1/tsort.rb:148:in “tsort_each'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/initializable.r
b:54:in “run_initializers'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/application.rb:
300:in “initialize!'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/railtie.rb:194:
in “public_send'

from /usr/share/foreman/vendor/ruby/1.9.1/gems/railties-4.1.14.2/1ib/rails/railtie.rb:194:
in "method_missing'

O W W O

from /usr/share/foreman/config/environment.rb:5:in "<top (required)>"'
from config.ru:3:in "require'
from config.ru:3:in "block in <main>'

These are the two Ruby 1.9.3 platforms remaining, so it could only affect 1.9.3. Reverting the commit in #6924 lets the application
load normally.

Related issues:
Related to Foreman - Bug #6924: Ul should throw proper validation error while... Closed 08/05/2014

Associated revisions

Revision f7f6bd5e - 03/17/2016 05:02 AM - Dominic Cleal

fixes #14225 - add missing require for Resolv

Setting itself is explicitly required too, which will provide a better
error message in future for this and similar issues loading the class.

History

#1 - 03/16/2016 04:54 AM - Dominic Cleal

- Related to Bug #6924: Ul should throw proper validation error while updating some params with any random value(like utf-8 or -ve values) added

#2 - 03/16/2016 05:20 AM - Dominic Cleal

The underlying error in the Setting class (visible when adding a require_dependency from the initialiser for setting.rb) is:

[ pid=9283 thr=19585120 file=utils.rb:176 time=2016-03-16 09:15:16.074 ]: *** Exception NameError in PhusionPa
ssenger: :Rack::ApplicationSpawner (uninitialized constant Setting::Resolv) (process 9283, thread #<Thread:0x00
00000255b0c0>) :

from /usr/share/foreman/app/models/setting.rb:43:in "<class:Setting>'

from /usr/share/foreman/app/models/setting.rb:3:in “<top (required)>'

from /usr/share/foreman/config/initializers/foreman.rb:17:in “<top (required)>'

#3 - 03/16/2016 05:31 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3332 added

#4 - 03/17/2016 06:01 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset {7f6bd5e757e33617a5c6f707f6e949e619{4b97.
